#ifndef __COMMON_H__
#define __COMMON_H__

#include "allegro.h"

#include <vector>

#include "train/train.h"
#include "menu/menu.h"
#include "track/track.h"
#include "../shared/map/map.h"
#include "../shared/map/tileset/tileset.h"

using namespace std;


// Global variables:

extern menu 					*menu_c;
extern tileset				*tileset_c;
extern map 			 			*map_c;
extern train					*train_c;

extern vector<track>	*tracklist;

extern BITMAP 				*buffer;

// Camera:

extern int 						*camera_x;
extern int 						*camera_y;

extern int						*pos_x;
extern int 						*pos_y;

// Mouse stuff:

extern BITMAP 				*arrow;
extern BITMAP					*arrow_flip;
extern BITMAP					*arrow_place;	

// States:

extern bool						game_running;
extern bool 					game_pause;

extern bool						game_won;

extern bool						menu_show;

extern bool						level_over;

extern bool						level_won;
extern bool						level_lost;

extern bool						level_help;

extern bool						level_new;
extern char 					level_basename[32];
extern int						level_current;

void grey(BITMAP *);

void states();

#endif
