#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <cmath>


#include "allegro.h"
#include "aldumb.h"

#include "common.h"

#include "../shared/map/map.h"
#include "train/train.h"
#include "track/track.h"


using namespace std;

DUH 					*music;
AL_DUH_PLAYER *music_handler;

vector<string> help;

vector<int>		 pieces;

volatile int target_frames = 0;
volatile int frames = 0;
volatile int fps = 0;

volatile bool mouse_b_up = false;

// Increase 60 times / sec
void ticker()
{
	//frames++;
	target_frames++;
} END_OF_FUNCTION(ticker);

// Calculate fps 1 time / sec
void fpsproc()
{
	fps = frames;
	frames = 0;
} END_OF_FUNCTION(fpsproc);


// Check for special mouse moves:
void mouseproc(int flags)
{
	if(flags & MOUSE_FLAG_LEFT_UP)
		mouse_b_up = true;
}


void init(); void deinit();

int main(int argc, char *argv[])
{
	init();

	int y, x;
	y = x = 0;
	
	int camera_x = 0;
	int camera_y = 0;	



	// Game loop:
	while(game_running)
	{
		// Do logic:
		int actual_frames = target_frames; target_frames = 0;        
		for( ; actual_frames > 0 ; actual_frames--)
		{	
			al_poll_duh(music_handler);

			if(!game_pause)
			{
				if(mouse_b_up)
				{
					int cur_tile = map_c->get(1, mouse_x / TILE_W, mouse_y / TILE_H);
					if((*tracklist)[cur_tile].switchable())
					{
						map_c->set(1, mouse_x / TILE_W, mouse_y / TILE_H, (*tracklist)[cur_tile].switchto());
					}
					else if(cur_tile == 0)
					{

						map_c->set(1, mouse_x / TILE_W, mouse_y / TILE_H, pieces[0]);

						pieces.erase(pieces.begin());

						int p;
						do
						{
							p = rand() % tileset_c->count() - 2;
						} while((!(*tracklist)[p].up() &&  !(*tracklist)[p].down() && !(*tracklist)[p].left() && !(*tracklist)[p].right()) | (*tracklist)[p].switchable());

						pieces.push_back(p);
					}
					mouse_b_up = false;
				}

				if(key[KEY_ESC] && keypressed())
				{
					game_pause = true;
					menu_show = true;
					clear_keybuf();
				}

				if(key[KEY_SPACE] && keypressed())
				{
					game_pause = true;
					level_help = true;
					clear_keybuf();
				}

				// Check if we won:

				if(train_c->is_in_goal())
				{
					level_over 	= true;
					level_won = true;
					game_pause = true;
					menu_show = true;
				}
				// Check if we didn't won
				else if(train_c->is_crashed())
				{
					level_over 	= true;
					level_lost 	= true;
				 	game_pause = true;
					menu_show = true;
				}
				else
				{
					train_c->update();				
    	  }
			}
			else if(game_pause && level_help)
			{
				if(key[KEY_SPACE] && keypressed())
				{
					game_pause = false;
					level_help = false;
					clear_keybuf();
				}			
			}
			else if(game_pause && menu_show)
			{
				menu_c->update();
			}

		if(level_new)
		{
			stringstream lvl;
			lvl << "maps/" << level_basename << "_" << level_current << ".map";
			stringstream lvl_help;
			lvl_help << "maps/" << level_basename << "_" << level_current << ".txt";

			if(!exists(lvl.str().c_str()))
			{
				cout << "You beat the game, good work!" << endl;
				level_over = true;
				level_new = false;
				level_won = false;
				level_lost = false;
				//game_running = false;
				game_pause = true;
				menu_show = true;
				game_won = true;

			}
			else
			{

			help.clear();
			ifstream helpfile;
			helpfile.open(lvl_help.str().c_str());
			if(helpfile)
			{
				while(!helpfile.eof())
				{
					string tmp;
					getline(helpfile, tmp);
					help.push_back(tmp);
				}
			}
			helpfile.close();

			if(map_c 		!= NULL)delete map_c;
			if(train_c	!= NULL)delete train_c;


			// Create level and load the first one:	
			map_c = new map();	
			map_c->load(lvl.str().c_str());
 
			// Create the train:
		 	train_c = new train();

			y = x = 0;

			level_new = false;
			TRACE("New level %i loaded %s\n", level_current, lvl.str().c_str());

			pieces.clear();
			
			for(int i = 0; i < 3; i++)
			{
				int p;
				pieces.push_back(0);
				do
				{
					p = rand() % tileset_c->count() - 2;
					pieces[i] = p;
				} while((!(*tracklist)[p].up() &&  !(*tracklist)[p].down() && !(*tracklist)[p].left() && !(*tracklist)[p].right()) | (*tracklist)[p].switchable());
			}


			level_help = true;
			game_pause = true;
			}
		}
			states();
		}
	

		if(!game_pause)
		{
			// Do gfx:		

			map_c->render(buffer, tileset_c, camera_x, camera_y);
		
			if(!train_c->is_in_goal())
				train_c->render();

			textprintf_ex(buffer, font, 10, 20, makecol(0, 0, 0), -1, "FPS: %i ", fps);
		
			// Render the tile queue:
			rectfill(buffer, SCREEN_W - 3 * 32 - 6, SCREEN_H - 32 - 4, SCREEN_W, SCREEN_H, makecol(239, 220, 131));
			for(int i = 0; i < 3; i++)
			{
				masked_blit(tileset_c->tile[pieces[i]], buffer, 0, 0, (SCREEN_W -(TILE_W + 1) * 3) + (i) * TILE_W, SCREEN_H - TILE_H - 1, TILE_W, TILE_H);
			}


			// Render pointer:
			if((*tracklist)[map_c->get(1, mouse_x / TILE_W, mouse_y / TILE_H)].switchable())
			{
				masked_blit(arrow_flip, buffer, 0, 0, mouse_x, mouse_y, 32, 32);
			}
			else if(map_c->get(1, mouse_x / TILE_W, mouse_y / TILE_H) == 0)
			{
				masked_blit(arrow_place, buffer, 0, 0, mouse_x, mouse_y, 32, 32);	
			}
			else
			{
				
				masked_blit(arrow, buffer, 0, 0, mouse_x, mouse_y, 32, 32);
			}
			//textprintf_ex(buffer, font, mouse_x + 4 , mouse_y + 4, makecol(0, 0, 0), -1, "%i ", map_c->get(1, mouse_x / TILE_W, mouse_y / TILE_H));



		}
		else if(game_pause && level_help)
		{
				textprintf_ex(buffer, font, 0 , 40, makecol(0, 0, 0), -1, "Help size: %i ", help.size());

				rectfill(buffer, 20, 20, SCREEN_W - 20, SCREEN_H - 20, makecol(239, 220, 131));
				rect(buffer, 19, 19, SCREEN_W - 19, SCREEN_H - 19, makecol(0, 0, 0));				

				for(unsigned int i = 0; i < help.size(); i++)
				{
					textprintf_ex(buffer, font, 30 , 30 + 10 * i, makecol(0, 0, 0), -1, "%s ", help[i].c_str());
				}
		}
		else if(game_pause && menu_show)
		{
			menu_c->render();
		}

		//vsync();
		blit(buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);		
		
		//readkey();
		frames++;
		


	}	

	deinit();	
	return 0;
	
}
END_OF_MAIN();

void init()
{

	srand(time(NULL));

	allegro_init();
	atexit(&dumb_exit);

	dumb_register_stdfiles();
	
	if(install_sound(DIGI_AUTODETECT, MIDI_NONE, NULL) == -1)
	{
		cout << "Install sound failed: " << allegro_error << endl;

	}
	
	install_keyboard();
	install_mouse();
	install_timer();

	set_color_depth(16);

	if(set_gfx_mode(GFX_AUTODETECT_WINDOWED, 640, 480, 0, 0) != 0)
	{
		set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
		allegro_message("Error setting 16 bit graphics mode\n%s\n", allegro_error);
		exit(1);
	}	
	
	set_color_conversion(COLORCONV_TOTAL);
	
	LOCK_VARIABLE(target_frames);
	LOCK_VARIABLE(frames);
	LOCK_VARIABLE(fps);
  LOCK_VARIABLE(mouseup);

	LOCK_FUNCTION(ticker);
	LOCK_FUNCTION(fpsproc);
	LOCK_FUNCTION(send_info);
	LOCK_FUNCTION(mouseproc);

	mouse_callback = mouseproc;
	
	install_int_ex(ticker, BPS_TO_TIMER(60));	
	install_int_ex(fpsproc, BPS_TO_TIMER(1));

	buffer			= create_bitmap(SCREEN_W, SCREEN_H);

	// Load pointers:
	arrow  			= load_bitmap("images/arrow.pcx", NULL);
	arrow_flip  = load_bitmap("images/arrow_flip.pcx", NULL);
	arrow_place = load_bitmap("images/arrow_place.pcx", NULL);	

	// Load the tileset:
	tileset_c = new tileset;
	tileset_c->load("images/tileset.pcx");

	// Load the track configuration:
	set_config_file("track.dat");

	tracklist = new vector<track>;

	for(int i = 0; i < tileset_c->count(); i++)
	{
    char nr[16];	sprintf(nr, "Track%i", i);
		track tmp(get_config_int(nr, "up", 0), get_config_int(nr, "right", 0), get_config_int(nr, "down", 0), get_config_int(nr, "left", 0), get_config_int(nr, "switchto", 0));
		
		tracklist->push_back(tmp);
		TRACE("Added track %i to the list(up: %i, right: %i, down: %i, left: %i switch: %i\n", i, get_config_int(nr, "up", 0), get_config_int(nr, "right", 0), get_config_int(nr, "down", 0), get_config_int(nr, "left", 0), get_config_int(nr, "switchto", 0));
	}	

	// Create the menu:
	menu_c = new menu();

	map_c = NULL;
	train_c = NULL;

	game_running = true;
	game_pause 	= true;
	menu_show		= true;

	game_won   = false;

	level_help = false;
	
	music = dumb_load_it_quick("trainee.it");
	
	if(music == NULL)
		cout << "Wrong while loading music" << endl;
	else
		cout << "Loading music was fine, don't worry" << endl;


	music_handler = al_start_duh(music, 2, 0, 1.0, 4096, 44100);

	if(music_handler == NULL)
		cout << "Wrong while loading music" << endl;
	else
		cout << "Loading music was fine, don't worry" << endl;



}



void deinit()
{
	al_stop_duh(music_handler);

	unload_duh(music);
	
  destroy_bitmap(buffer);
	destroy_bitmap(arrow);
	destroy_bitmap(arrow_flip);
	destroy_bitmap(arrow_place);

	delete tracklist;
	delete map_c;
	delete tileset_c;
	delete menu_c;
	
	set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
  cout << "So long and thanks for the fish" << endl;

}
