#include "../map.h"
#include "tileset.h"


tileset::tileset()
{
 TRACE("Tileset: Reached Constructor\n");

 tile = NULL;

}

tileset::~tileset()
{
 TRACE("Tileset: Reached Deconstructor\n");

 if(tile != NULL)
 {
  for(int i = 0; i < tiles; i++)
  {
   TRACE("Tileset - destructor: Destroying image %i\n", i);
   destroy_bitmap(tile[i]);
  }

  delete[] tile;
  TRACE("Tileset - destructor: Deleted list\n");
 }
}

bool tileset::load(const char *tileset)
{
 TRACE("Tileset - load: Trying to load the %s tileset\n", tileset);
 TRACE("Tileset - load: Tiles should be %i x %i\n", TILE_W, TILE_H);
                      
 BITMAP *tmp = load_pcx(tileset, NULL);
 
 if(tmp)
 { 
  int tile_w = (tmp->w -1) / (TILE_W + 1);
  int tile_h = (tmp->h -1) / (TILE_H + 1);
  
  tiles = tile_w * tile_h;
  
  TRACE("Tileset - load: Tileset is (%i, %i) with %i tiles wide and %i high with a total of %i tiles\n", tmp->h, tmp->w, tile_w, tile_h, tiles);
  
  tile = new BITMAP *[tiles];  
  
  for(int i = 0; i < tiles; i++)
  {
   tile[i] = create_bitmap(TILE_W, TILE_H);
  }
 
  TRACE("Tileset - load: Done creating tiles\n");  
  
  int i = 0;
  for(int y = 0; y < tile_h; y++)
  {
   for(int x = 0; x < tile_w; x++)
   {
    TRACE("Tileset - load: Loading image for tile nr %i (from %i, %i) ... ", i, x, y);
    
    blit(tmp, tile[i++], x * (TILE_W + 1) + 1, y * (TILE_H + 1) + 1, 0, 0, TILE_W, TILE_H);
    //blit(tile[i-1], screen, 0, 0, 0, 0, TILE_W, TILE_H);

    //readkey();
    TRACE("Done!\n");
    
   }
  }

  TRACE("Tileset - load: Finished loading images into tiles\n");
  
  destroy_bitmap(tmp);
  
  return true;
 }
 else
 {
  TRACE("Tileset - load: Failed to open the tileset\n");
  return false;    
 }
                   
}
